| The Gaudi Framework v27r1

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Private Attributes | List of all members
SharedObjectsContainer< TYPE > Class Template Reference

Very simple class to represent the container of objects which are not ownered by the container. More...

`#include <GaudiKernel/SharedObjectsContainer.h>`

Inheritance diagram for SharedObjectsContainer< TYPE >:
[legend]
Collaboration diagram for SharedObjectsContainer< TYPE >:
[legend]

## Public Types
typedef std::vector< const TYPE * > | ConstVector
| the actual container type More...
typedef ConstVector::value_type | value_type
| various types (to make STL happy) More...
typedef ConstVector::size_type | size_type
typedef ConstVector::reference | reference
typedef ConstVector::const_reference | const_reference
typedef ConstVector::iterator | iterator
typedef ConstVector::const_iterator | const_iterator
typedef ConstVector::reverse_iterator | reverse_iterator
typedef ConstVector::const_reverse_iterator | const_reverse_iterator
Public Types inherited from ObjectContainerBase
typedef size_t | size_type
| size_type, to conform the STL container interface More...

## Public Member Functions
| SharedObjectsContainer ()
| SharedObjectsContainer (const ConstVector &data)
template<class DATA >
| SharedObjectsContainer (DATA first, DATA last)
| the templated constructor from the pair of iterators More...
template<class DATA , class PREDICATE >
| SharedObjectsContainer (DATA first, DATA last, const PREDICATE &cut)
| the templated constructor from the pair of iterators and the predicate. More...
virtual | ~SharedObjectsContainer ()
| destructor More...
virtual const CLID & | clID () const
| Retrieve the unique class ID (virtual) More...
const ConstVector & | data () const
| get the access to the underlying container (const) More...
| operator const ConstVector & () const
| cast to the underlying container More...
size_type | size () const
| get the actual size of the container More...
bool | empty () const
| empty container? More...
void | push_back (const TYPE *object)
| insert one object into the container More...
void | insert (const TYPE *object)
| insert one object into the container More...
template<class DATA >
void | insert (DATA first, DATA last)
| add the sequence of objects into the container More...
template<class DATA , class PREDICATE >
void | insert (DATA first, DATA last, const PREDICATE &cut)
| add the sequence of 'good'objects into the container More...
template<class OUTPUT , class PREDICATE >
OUTPUT | get (const PREDICATE &cut, OUTPUT output) const
| get from the container all objects which satisfy the certain criteria More...
void | erase (iterator i)
| erase the object by iterator More...
template<class PREDICATE >
void | erase (const PREDICATE &cut)
| erase the objects which satisfy the criteria More...
bool | erase (const TYPE *object)
| erase the first occurance of the certain element More...
reference | operator[] (size_type index)
| index access More...
const_reference | operator[] (size_type index) const
| index access (const-version) More...
reference | operator() (size_type index)
| 'functional'-access More...
const_reference | operator() (size_type index) const
| 'functional'-access (const version) More...
reference | at (size_type index)
| checked access More...
const_reference | at (size_type index) const
| checked access (const-version) More...
iterator | begin ()
iterator | end ()
const_iterator | begin () const
const_iterator | end () const
reverse_iterator | rbegin ()
reverse_iterator | rend ()
const_reverse_iterator | rbegin () const
const_reverse_iterator | rend () const
reference | front ()
| the first element (only for non-empty vectors) More...
const_reference | front () const
| the first element (only for non-empty vectors) (const-version) More...
reference | back ()
| the last element (only for non-empty vectors) More...
const_reference | back () const
| the last element (only for non-empty vectors) (const-version) More...
bool | operator== (const SharedObjectsContainer &right) const
| equal content with other container ? More...
bool | operator== (const ConstVector &right) const
| equal content with corresponding vector ? More...
bool | operator< (const SharedObjectsContainer &right) const
| comparisons with other container More...
bool | operator< (const ConstVector &right) const
| comparisons with corresponding vector More...
virtual long | index (const ContainedObject *object) const
| Distance of a given object from the beginning of its container. More...
virtual ContainedObject * | containedObject (long index) const
| Pointer to an object of a given distance. More...
virtual size_type | numberOfObjects () const
| Number of objects in the container. More...
virtual long | add (ContainedObject *object)
| Virtual functions (forwards to the concrete container definitions) Add an object to the container. More...
virtual long | remove (ContainedObject *value)
| Release object from the container (the pointer will be removed from the container, but the object itself will remain alive). More...
Public Member Functions inherited from DataObject
| DataObject ()
| Standard Constructor. More...
| DataObject (const DataObject &rhs)
| Copy Constructor. More...
DataObject & | operator= (const DataObject &rhs)
| Assignment Operator. More...
| DataObject (DataObject &&rhs)
| Move Constructor. More...
DataObject & | operator= (DataObject &&rhs)
| Move Assignment Operator. More...
virtual | ~DataObject ()
| Standard Destructor. More...
virtual unsigned long | addRef ()
| Add reference to object. More...
virtual unsigned long | release ()
| release reference to object More...
const std::string & | name () const
| Retreive DataObject name. It is the name when registered in the store. More...
virtual StatusCode | update ()
| Provide empty placeholder for internal object reconfiguration callback. More...
void | setRegistry (IRegistry *pRegistry)
| Set pointer to Registry. More...
IRegistry * | registry () const
| Get pointer to Registry. More...
LinkManager * | linkMgr () const
| Retrieve Link manager. More...
unsigned char | version () const
| Retrieve version number of this object representation. More...
void | setVersion (unsigned char vsn)
| Set version number of this object representation. More...
unsigned long | refCount () const
| Return the refcount. More...
virtual std::ostream & | fillStream (std::ostream &s) const
| Fill the output stream (ASCII) More...

## Static Public Member Functions
static const CLID & | classID ()
| Retrieve the unuqie class ID (static) More...
Static Public Member Functions inherited from DataObject
static const CLID & | classID ()
| Retrieve reference to class definition structure (static access) More...

## Private Attributes
ConstVector | m_data

## Additional Inherited Members
Protected Member Functions inherited from ObjectContainerBase
| ObjectContainerBase ()=default
| Constructor. More...
| ~ObjectContainerBase () override=default
| Destructor. More...

## Detailed Description

### template<class TYPE>
class SharedObjectsContainer< TYPE >

Very simple class to represent the container of objects which are not ownered by the container.

This concept seem to be very useful for LHCb HLT, DaVinci, tracking, alignments.

Warning
  the container is not persistable (on-purpose)

Author
  Vanya BELYAEV Ivan..nosp@m.Bely.nosp@m.aev@n.nosp@m.ikhe.nosp@m.f.nl

Date
  2008-07-23

Definition at line 28 of file SharedObjectsContainer.h.

## Member Typedef Documentation

template<class TYPE >

typedef ConstVector::const_iterator SharedObjectsContainer< TYPE >::const_iterator

Definition at line 40 of file SharedObjectsContainer.h.

template<class TYPE >

typedef ConstVector::const_reference SharedObjectsContainer< TYPE >::const_reference

Definition at line 38 of file SharedObjectsContainer.h.

template<class TYPE >

typedef ConstVector::const_reverse_iterator SharedObjectsContainer< TYPE >::const_reverse_iterator

Definition at line 42 of file SharedObjectsContainer.h.

template<class TYPE >

typedef std::vector<const TYPE*> SharedObjectsContainer< TYPE >::ConstVector

the actual container type

Definition at line 33 of file SharedObjectsContainer.h.

template<class TYPE >

typedef ConstVector::iterator SharedObjectsContainer< TYPE >::iterator

Definition at line 39 of file SharedObjectsContainer.h.

template<class TYPE >

typedef ConstVector::reference SharedObjectsContainer< TYPE >::reference

Definition at line 37 of file SharedObjectsContainer.h.

template<class TYPE >

typedef ConstVector::reverse_iterator SharedObjectsContainer< TYPE >::reverse_iterator

Definition at line 41 of file SharedObjectsContainer.h.

template<class TYPE >

typedef ConstVector::size_type SharedObjectsContainer< TYPE >::size_type

Definition at line 36 of file SharedObjectsContainer.h.

template<class TYPE >

typedef ConstVector::value_type SharedObjectsContainer< TYPE >::value_type

various types (to make STL happy)

Definition at line 35 of file SharedObjectsContainer.h.

## Constructor & Destructor Documentation

template<class TYPE >

SharedObjectsContainer< TYPE >::SharedObjectsContainer | ( |  | ) |
| inline

Definition at line 47 of file SharedObjectsContainer.h.

48 : ObjectContainerBase(), m_data() {} ;
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
ObjectContainerBase::ObjectContainerBase
ObjectContainerBase()=default
Constructor.
template<class TYPE >

SharedObjectsContainer< TYPE >::SharedObjectsContainer | ( | const ConstVector & | data | ) |
| inline

Definition at line 50 of file SharedObjectsContainer.h.

51 : ObjectContainerBase(), m_data(data) {}
SharedObjectsContainer::data
const ConstVector & data() const
get the access to the underlying container (const)
Definition: SharedObjectsContainer.h:113
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
ObjectContainerBase::ObjectContainerBase
ObjectContainerBase()=default
Constructor.
template<class TYPE >
template<class DATA >

SharedObjectsContainer< TYPE >::SharedObjectsContainer | ( | DATA | first,
|  | DATA | last
| ) |  |
| inline

the templated constructor from the pair of iterators

Parameters

  first | 'begin'-iterator of the input sequence
  last | 'last'-iterator of the input sequence

Definition at line 57 of file SharedObjectsContainer.h.

58 : ObjectContainerBase(), m_data(first, last) {}
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
ObjectContainerBase::ObjectContainerBase
ObjectContainerBase()=default
Constructor.
template<class TYPE >
template<class DATA , class PREDICATE >

SharedObjectsContainer< TYPE >::SharedObjectsContainer | ( | DATA | first,
|  | DATA | last,
|  | const PREDICATE & | cut
| ) |  |
| inline

the templated constructor from the pair of iterators and the predicate.

Only the elements which satisfy the criteria goes into the container e.g. create the container only with "basic" particles:

typedef SharedObjectsContainer<LHCb::Particle> PARTICLES ;
// some sequence of someting, convertiblle to "const LHCb::Particle*":
SEQUENCE source = ... ;
PARTICLES* particles = new PARTICLES
( source.begin() ,
source.end () ,
std::mem_fun(&LHCb::Particle::isBasic) ) ;

Parameters

  first | 'begin'-iterator if the input sequence
  last | 'last'-iterator of the input sequence
  cut | pre predicate

Definition at line 83 of file SharedObjectsContainer.h.

84 : ObjectContainerBase(), m_data()
85 {
86 insert ( first , last , cut ) ;
87 }
SharedObjectsContainer::insert
void insert(const TYPE *object)
insert one object into the container
Definition: SharedObjectsContainer.h:130
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
ObjectContainerBase::ObjectContainerBase
ObjectContainerBase()=default
Constructor.
template<class TYPE >

virtual SharedObjectsContainer< TYPE >::~SharedObjectsContainer | ( |  | ) |
| inline virtual

destructor

Definition at line 89 of file SharedObjectsContainer.h.

89 { m_data.clear() ; }
std::vector::clear
T clear(T...args)
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360

## Member Function Documentation

template<class TYPE >

virtual long SharedObjectsContainer< TYPE >::add | ( | ContainedObject * | object | ) |
| inline virtual

Virtual functions (forwards to the concrete container definitions) Add an object to the container.

On success the object's index is returned.

Implements ObjectContainerBase.

Definition at line 335 of file SharedObjectsContainer.h.

336 {
337 if ( !object ) { return -1 ; } // RETURN
338 TYPE* _obj = dynamic_cast<TYPE*> ( object ) ;
339 if ( !_obj ) { return -1 ; } // RETURN
340 const size_type pos = size() ;
341 push_back ( _obj ) ;
342 return pos ;
343 }
SharedObjectsContainer::push_back
void push_back(const TYPE *object)
insert one object into the container
Definition: SharedObjectsContainer.h:126
SharedObjectsContainer::size_type
ConstVector::size_type size_type
Definition: SharedObjectsContainer.h:36
SharedObjectsContainer::size
size_type size() const
get the actual size of the container
Definition: SharedObjectsContainer.h:120
template<class TYPE >

reference SharedObjectsContainer< TYPE >::at | ( | size_type | index | ) |
| inline

checked access

Definition at line 268 of file SharedObjectsContainer.h.

268 { return m_data.at(index) ; }
std::vector::at
T at(T...args)
SharedObjectsContainer::index
virtual long index(const ContainedObject *object) const
Distance of a given object from the beginning of its container.
Definition: SharedObjectsContainer.h:314
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

const_reference SharedObjectsContainer< TYPE >::at | ( | size_type | index | ) | const
| inline

checked access (const-version)

Definition at line 270 of file SharedObjectsContainer.h.

270 { return m_data.at(index) ; }
std::vector::at
T at(T...args)
SharedObjectsContainer::index
virtual long index(const ContainedObject *object) const
Distance of a given object from the beginning of its container.
Definition: SharedObjectsContainer.h:314
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

reference SharedObjectsContainer< TYPE >::back | ( |  | ) |
| inline

the last element (only for non-empty vectors)

Definition at line 290 of file SharedObjectsContainer.h.

290 { return m_data . back () ; }
SharedObjectsContainer::back
reference back()
the last element (only for non-empty vectors)
Definition: SharedObjectsContainer.h:290
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

const_reference SharedObjectsContainer< TYPE >::back | ( |  | ) | const
| inline

the last element (only for non-empty vectors) (const-version)

Definition at line 292 of file SharedObjectsContainer.h.

292 { return m_data . back () ; }
SharedObjectsContainer::back
reference back()
the last element (only for non-empty vectors)
Definition: SharedObjectsContainer.h:290
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

iterator SharedObjectsContainer< TYPE >::begin | ( |  | ) |
| inline

Definition at line 274 of file SharedObjectsContainer.h.

274 { return m_data . begin () ; }
SharedObjectsContainer::begin
iterator begin()
Definition: SharedObjectsContainer.h:274
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

const_iterator SharedObjectsContainer< TYPE >::begin | ( |  | ) | const
| inline

Definition at line 276 of file SharedObjectsContainer.h.

276 { return m_data . begin () ; }
SharedObjectsContainer::begin
iterator begin()
Definition: SharedObjectsContainer.h:274
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

static const CLID& SharedObjectsContainer< TYPE >::classID | ( |  | ) |
| inline static

Retrieve the unuqie class ID (static)

Definition at line 97 of file SharedObjectsContainer.h.

98 {
99 static const CLID s_clid =
100 ( ( static_cast<CLID> ( -1 ) << 16 ) // 16 used and 16 empty bits
101 & !CLID_ObjectVector // not an ObjectVector
102 & !CLID_ObjectList // not an ObjectList
103 & !static_cast<CLID> ( 0x00030000 ) // not a KeyedContainer/map
104 & !static_cast<CLID> ( 0x00040000 ) )// not a KeyedContainer/hashmap
105 + TYPE::classID() ; // the specific CLID from the contents
106 //
107 return s_clid;
108 }
CLID
unsigned int CLID
Class ID definition.
Definition: ClassID.h:8
template<class TYPE >

virtual const CLID& SharedObjectsContainer< TYPE >::clID | ( |  | ) | const
| inline virtual

Retrieve the unique class ID (virtual)

Reimplemented from DataObject.

Definition at line 94 of file SharedObjectsContainer.h.

95 { return SharedObjectsContainer<TYPE>::classID(); }
SharedObjectsContainer::classID
static const CLID & classID()
Retrieve the unuqie class ID (static)
Definition: SharedObjectsContainer.h:97
template<class TYPE >

virtual ContainedObject* SharedObjectsContainer< TYPE >::containedObject | ( | long | index | ) | const
| inline virtual

Pointer to an object of a given distance.

Parameters

  index | th eindex to be checked

Returns
  the object

Implements ObjectContainerBase.

Definition at line 323 of file SharedObjectsContainer.h.

324 {
325 if ( 0 > index || !(index < (long) size () ) ) { return 0 ; } // RETURN
326 const ContainedObject* co = m_data[index] ;
327 return const_cast<ContainedObject*>( co ) ;
328 }
SharedObjectsContainer::size
size_type size() const
get the actual size of the container
Definition: SharedObjectsContainer.h:120
SharedObjectsContainer::index
virtual long index(const ContainedObject *object) const
Distance of a given object from the beginning of its container.
Definition: SharedObjectsContainer.h:314
ContainedObject
All classes that their objects may be contained in an LHCb ObjectContainer (e.g.
Definition: ContainedObject.h:29
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

const ConstVector& SharedObjectsContainer< TYPE >::data | ( |  | ) | const
| inline

get the access to the underlying container (const)

Definition at line 113 of file SharedObjectsContainer.h.

113 { return m_data ; }
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

bool SharedObjectsContainer< TYPE >::empty | ( |  | ) | const
| inline

empty container?

Definition at line 122 of file SharedObjectsContainer.h.

122 { return m_data.empty () ; }
std::vector::empty
T empty(T...args)
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

iterator SharedObjectsContainer< TYPE >::end | ( |  | ) |
| inline

Definition at line 275 of file SharedObjectsContainer.h.

275 { return m_data . end () ; }
SharedObjectsContainer::end
iterator end()
Definition: SharedObjectsContainer.h:275
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

const_iterator SharedObjectsContainer< TYPE >::end | ( |  | ) | const
| inline

Definition at line 277 of file SharedObjectsContainer.h.

277 { return m_data . end () ; }
SharedObjectsContainer::end
iterator end()
Definition: SharedObjectsContainer.h:275
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

void SharedObjectsContainer< TYPE >::erase | ( | iterator | i | ) |
| inline

erase the object by iterator

Definition at line 210 of file SharedObjectsContainer.h.

210 { m_data.erase ( i ) ; }
std::vector::erase
T erase(T...args)
ana.i
list i
Definition: ana.py:128
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >
template<class PREDICATE >

void SharedObjectsContainer< TYPE >::erase | ( | const PREDICATE & | cut | ) |
| inline

erase the objects which satisfy the criteria

E.g. remove all particles with small transverse momentum

namespace bl = boost::lambda ;
typedef SharedObjectsContainer<LHCb::Particle> PARTICLES ;
PARTICLES* particles = ... ;
particles -> erase
( bl::bind(&LHCb::Particle::pt,bl::_1) < 1 * Gaudi::Units::GeV ) ;

See also
  std::remove_if

Parameters

  cut | predicate

Definition at line 229 of file SharedObjectsContainer.h.

230 { m_data.erase( std::remove_if ( begin() , end() , cut ) , end() ) ; }
std::remove_if
T remove_if(T...args)
SharedObjectsContainer::begin
iterator begin()
Definition: SharedObjectsContainer.h:274
std::vector::erase
T erase(T...args)
SharedObjectsContainer::end
iterator end()
Definition: SharedObjectsContainer.h:275
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

bool SharedObjectsContainer< TYPE >::erase | ( | const TYPE * | object | ) |
| inline

erase the first occurance of the certain element

To remove all occurances one can use:

typedef SharedObjectsContainer<LHCb::Particle> PARTICLES ;
PARTICLES* particles = ... ;
const LHCb::Particle* B = ... ;
// remove all occurances
while ( particles -> erase ( B ) ) {} ;

Parameters

  object | the element to be removed

Returns
  true if the element is removed

Definition at line 249 of file SharedObjectsContainer.h.

250 {
251 auto i = std::find ( begin() , end() , object ) ;
252 if ( end() == i ) { return false ; }
253 m_data.erase ( i ) ;
254 return true ;
255 }
SharedObjectsContainer::begin
iterator begin()
Definition: SharedObjectsContainer.h:274
std::vector::erase
T erase(T...args)
SharedObjectsContainer::end
iterator end()
Definition: SharedObjectsContainer.h:275
std::find
T find(T...args)
ana.i
list i
Definition: ana.py:128
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

reference SharedObjectsContainer< TYPE >::front | ( |  | ) |
| inline

the first element (only for non-empty vectors)

Definition at line 286 of file SharedObjectsContainer.h.

286 { return m_data . front () ; }
SharedObjectsContainer::front
reference front()
the first element (only for non-empty vectors)
Definition: SharedObjectsContainer.h:286
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

const_reference SharedObjectsContainer< TYPE >::front | ( |  | ) | const
| inline

the first element (only for non-empty vectors) (const-version)

Definition at line 288 of file SharedObjectsContainer.h.

288 { return m_data . front () ; }
SharedObjectsContainer::front
reference front()
the first element (only for non-empty vectors)
Definition: SharedObjectsContainer.h:286
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >
template<class OUTPUT , class PREDICATE >

OUTPUT SharedObjectsContainer< TYPE >::get | ( | const PREDICATE & | cut,
|  | OUTPUT | output
| ) |  | const
| inline

get from the container all objects which satisfy the certain criteria

E.g. get all particles with transverse momentum in excess of 1 * GeV

namespace bl = boost::lambda ;
typedef SharedObjectsContainer<LHCb::Particle> PARTICLES ;
typedef std::vector<const LHCb::Particle*> TARGET ;
PARTICLES* particles = ... ;
TARGET target ;
particles -> get
( bl::bind(&LHCb::Particle::pt,bl::_1) > 1 * Gaudi::Units::GeV ,
std::back_inserter ( target ) ) ;

Essentially this functionality is very useful due to missing "std::copy_if".

Parameters

  cut | the predicate
  outptut | the output iterator

Returns
  the current position of the output itrator (almost useless)

Definition at line 203 of file SharedObjectsContainer.h.

205 {
206 std::copy_if( begin(), end(), output, std::cref(cut) );
207 return output ;
208 }
std::copy_if
T copy_if(T...args)
SharedObjectsContainer::begin
iterator begin()
Definition: SharedObjectsContainer.h:274
SharedObjectsContainer::end
iterator end()
Definition: SharedObjectsContainer.h:275
std::cref
T cref(T...args)
template<class TYPE >

virtual long SharedObjectsContainer< TYPE >::index | ( | const ContainedObject * | object | ) | const
| inline virtual

Distance of a given object from the beginning of its container.

Parameters

  object | the object to be checked

Implements ObjectContainerBase.

Definition at line 314 of file SharedObjectsContainer.h.

315 {
316 auto _i = std::find ( begin() , end() , object ) ;
317 return end() != _i ? ( _i - begin() ) : -1 ; // RETURN
318 }
SharedObjectsContainer::begin
iterator begin()
Definition: SharedObjectsContainer.h:274
SharedObjectsContainer::end
iterator end()
Definition: SharedObjectsContainer.h:275
std::find
T find(T...args)
template<class TYPE >

void SharedObjectsContainer< TYPE >::insert | ( | const TYPE * | object | ) |
| inline

insert one object into the container

Parameters

  object | object to be added

Definition at line 130 of file SharedObjectsContainer.h.

130 { m_data.push_back ( object ) ; }
std::vector::push_back
T push_back(T...args)
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >
template<class DATA >

void SharedObjectsContainer< TYPE >::insert | ( | DATA | first,
|  | DATA | last
| ) |  |
| inline

add the sequence of objects into the container

Parameters

  first | 'begin'-iterator for the sequnce
  last | 'end'-iterator for the sequence

Definition at line 137 of file SharedObjectsContainer.h.

138 { m_data.insert ( end() , first ,last ) ; }
SharedObjectsContainer::end
iterator end()
Definition: SharedObjectsContainer.h:275
std::vector::insert
T insert(T...args)
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >
template<class DATA , class PREDICATE >

void SharedObjectsContainer< TYPE >::insert | ( | DATA | first,
|  | DATA | last,
|  | const PREDICATE & | cut
| ) |  |
| inline

add the sequence of 'good'objects into the container

Only the objects which satisfy the predicate go to the container, e.g. put into container only particles which transverse momentum in excess of 1 * GeV:

namespace bl = boost::lambda ;
typedef SharedObjectsContainer<LHCb::Particle> PARTICLES ;
// some sequence of someting, convertible to "const LHCb::Particle*":
SEQUENCE source = ... ;
PARTICLES* particles = ... ;
particles -> insert
( source.begin() ,
source.end () ,
bl::bind(&LHCb::Particle::pt,bl::_1) > 1 * Gaudi::Units::GeV ) ;

Parameters

  first | 'begin'-iterator for the sequnce
  last | 'end'-iterator for the sequence
  cut | the predicate to be applied

Definition at line 167 of file SharedObjectsContainer.h.

170 {
171 m_data.reserve ( m_data.size() + std::distance ( first , last ) ) ;
172 for ( ; first != last ; ++first )
173 { if ( cut ( *first ) ) { m_data.push_back ( *first ) ; } }
174 }
std::distance
T distance(T...args)
std::vector::push_back
T push_back(T...args)
std::vector::size
T size(T...args)
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
std::vector::reserve
T reserve(T...args)
template<class TYPE >

virtual size_type SharedObjectsContainer< TYPE >::numberOfObjects | ( |  | ) | const
| inline virtual

Number of objects in the container.

Implements ObjectContainerBase.

Definition at line 330 of file SharedObjectsContainer.h.

330 { return m_data.size() ; }
std::vector::size
T size(T...args)
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

SharedObjectsContainer< TYPE >::operator const ConstVector & | ( |  | ) | const
| inline

cast to the underlying container

Definition at line 115 of file SharedObjectsContainer.h.

115 { return data () ; }
SharedObjectsContainer::data
const ConstVector & data() const
get the access to the underlying container (const)
Definition: SharedObjectsContainer.h:113
template<class TYPE >

reference SharedObjectsContainer< TYPE >::operator() | ( | size_type | index | ) |
| inline

'functional'-access

Definition at line 264 of file SharedObjectsContainer.h.

264 { return m_data [index] ; }
SharedObjectsContainer::index
virtual long index(const ContainedObject *object) const
Distance of a given object from the beginning of its container.
Definition: SharedObjectsContainer.h:314
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

const_reference SharedObjectsContainer< TYPE >::operator() | ( | size_type | index | ) | const
| inline

'functional'-access (const version)

Definition at line 266 of file SharedObjectsContainer.h.

266 { return m_data [index] ; }
SharedObjectsContainer::index
virtual long index(const ContainedObject *object) const
Distance of a given object from the beginning of its container.
Definition: SharedObjectsContainer.h:314
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

bool SharedObjectsContainer< TYPE >::operator< | ( | const SharedObjectsContainer< TYPE > & | right | ) | const
| inline

comparisons with other container

Definition at line 303 of file SharedObjectsContainer.h.

304 { return m_data < right.m_data ; }
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

bool SharedObjectsContainer< TYPE >::operator< | ( | const ConstVector & | right | ) | const
| inline

comparisons with corresponding vector

Definition at line 306 of file SharedObjectsContainer.h.

307 { return m_data < right ; }
std::right
T right(T...args)
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

bool SharedObjectsContainer< TYPE >::operator== | ( | const SharedObjectsContainer< TYPE > & | right | ) | const
| inline

equal content with other container ?

Definition at line 297 of file SharedObjectsContainer.h.

298 { return &right == this || right.m_data == m_data ; }
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

bool SharedObjectsContainer< TYPE >::operator== | ( | const ConstVector & | right | ) | const
| inline

equal content with corresponding vector ?

Definition at line 300 of file SharedObjectsContainer.h.

301 { return m_data == right ; }
std::right
T right(T...args)
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

reference SharedObjectsContainer< TYPE >::operator[] | ( | size_type | index | ) |
| inline

index access

Definition at line 260 of file SharedObjectsContainer.h.

260 { return m_data [index] ; }
SharedObjectsContainer::index
virtual long index(const ContainedObject *object) const
Distance of a given object from the beginning of its container.
Definition: SharedObjectsContainer.h:314
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

const_reference SharedObjectsContainer< TYPE >::operator[] | ( | size_type | index | ) | const
| inline

index access (const-version)

Definition at line 262 of file SharedObjectsContainer.h.

262 { return m_data [index] ; }
SharedObjectsContainer::index
virtual long index(const ContainedObject *object) const
Distance of a given object from the beginning of its container.
Definition: SharedObjectsContainer.h:314
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

void SharedObjectsContainer< TYPE >::push_back | ( | const TYPE * | object | ) |
| inline

insert one object into the container

Parameters

  object | object to be added

Definition at line 126 of file SharedObjectsContainer.h.

126 { m_data.push_back ( object ) ; }
std::vector::push_back
T push_back(T...args)
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

reverse_iterator SharedObjectsContainer< TYPE >::rbegin | ( |  | ) |
| inline

Definition at line 278 of file SharedObjectsContainer.h.

278 { return m_data . rbegin () ; }
SharedObjectsContainer::rbegin
reverse_iterator rbegin()
Definition: SharedObjectsContainer.h:278
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

const_reverse_iterator SharedObjectsContainer< TYPE >::rbegin | ( |  | ) | const
| inline

Definition at line 280 of file SharedObjectsContainer.h.

280 { return m_data . rbegin () ; }
SharedObjectsContainer::rbegin
reverse_iterator rbegin()
Definition: SharedObjectsContainer.h:278
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

virtual long SharedObjectsContainer< TYPE >::remove | ( | ContainedObject * | value | ) |
| inline virtual

Release object from the container (the pointer will be removed from the container, but the object itself will remain alive).

If the object was found it's index is returned.

Implements ObjectContainerBase.

Definition at line 348 of file SharedObjectsContainer.h.

349 {
350 auto _i = std::find ( begin() , end() , value ) ;
351 if ( end() == _i ) { return -1 ; } // RETURN
352 const size_type pos = _i - begin() ;
353 m_data.erase ( _i ) ;
354 return pos ; // RETURN
355 }
SharedObjectsContainer::size_type
ConstVector::size_type size_type
Definition: SharedObjectsContainer.h:36
SharedObjectsContainer::begin
iterator begin()
Definition: SharedObjectsContainer.h:274
std::vector::erase
T erase(T...args)
SharedObjectsContainer::end
iterator end()
Definition: SharedObjectsContainer.h:275
std::find
T find(T...args)
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

reverse_iterator SharedObjectsContainer< TYPE >::rend | ( |  | ) |
| inline

Definition at line 279 of file SharedObjectsContainer.h.

279 { return m_data . rend () ; }
SharedObjectsContainer::rend
reverse_iterator rend()
Definition: SharedObjectsContainer.h:279
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

const_reverse_iterator SharedObjectsContainer< TYPE >::rend | ( |  | ) | const
| inline

Definition at line 281 of file SharedObjectsContainer.h.

281 { return m_data . rend () ; }
SharedObjectsContainer::rend
reverse_iterator rend()
Definition: SharedObjectsContainer.h:279
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360
template<class TYPE >

size_type SharedObjectsContainer< TYPE >::size | ( |  | ) | const
| inline

get the actual size of the container

Definition at line 120 of file SharedObjectsContainer.h.

120 { return m_data.size () ; }
std::vector::size
T size(T...args)
SharedObjectsContainer::m_data
ConstVector m_data
Definition: SharedObjectsContainer.h:360

## Member Data Documentation

template<class TYPE >

ConstVector SharedObjectsContainer< TYPE >::m_data
| private

Definition at line 360 of file SharedObjectsContainer.h.

The documentation for this class was generated from the following file:

- GaudiKernel/GaudiKernel/SharedObjectsContainer.h